;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; Vereinfach
;
; Die Funktion ndert bei jedem der gewhlten Objekte den zugehrigen Layer
; auf den derzeit aktuellen. Farbe und Linientypen werden dabei erhalten.
; Zuordnungen bei VONLAER werden entsprechend gendert, so da sich die Anzeige
; nicht ndert
;
; Aufruf: vereinfach
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; (c) Dipl.-Ing.  Volker Kleppel
; http://www.cadwerk.com
; vkleppel@gmx.de
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; Version: 1.1                      Datum: 20.05.2018
; AutoCAD12   [ ]  AutoCAD14   [ ]  AutoCAD2000(i) [x]   
; AutoCAD2002 [x]  AutoCAD2004 [x]  AutoCAD2005    [x]
; AutoCAD2006 [x]  AutoCAD2007 [x]  AutoCAD2008    [x]
; AutoCAD2009 [x]  AutoCAD2010 [x]  AutoCAD2011    [x]
; AutoCAD2012 [x]  AutoCAD2013 [x]  AutoCAD2014    [x]
; AutoCAD2015 [x]  AutoCAD2016 [x]  AutoCAD2017    [x]
; AutoCAD2018 [x]  AutoCAD2019 [x]
; Freeware    [x]  Shareware   [ ]
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

;;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;; Vereinfach
;;
;; Funktion reduziert alle gewhlten Elemente auf einen Layer, wobei deren Farbe
;; erhalten bleibt
;;
;; Stand: 2.12.1999 / voke
;;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

(defun c:vereinfach ( / syscmdecho pointer clayer entlayer entcolor entlayercolor en ent anz)

	;Initialisieren
	(setq clayer (getvar "CLAYER"))
	(setq pointer 0)
	(setq syscmdecho (getvar "cmdecho"))
	(setvar "CMDECHO" 0)

	;Auswahlsatz
	(princ "\nObjekte zum Zusammenfassen whlen  ")
	(setq aw (ssget))

	(command "_.undo" "beginn")

	;Zusammenfassen
	(if (/= aw nil)
		(progn
		  	(setq anz (sslength aw))
		  	(setq anz (atof (strcat (rtos anz 2 0) ".0")))
			(setq en (ssname aw 0))
			(while (/= en nil)

				(setq ent (entget en))
				(setq entLayer (cdr (assoc 8 ent)))
				(setq entColor (cdr (assoc 62 ent)))
				(setq entLTyp (cdr (assoc 6 ent)))

				(setq entLayerColor (cdr (assoc 62 (tblsearch "layer" entlayer))))
				(setq entLayerLTyp (cdr (assoc 6 (tblsearch "layer" entlayer))))

				(if (or (not entColor) (= entColor 256)) (setq entColor entLayerColor))
				(if (not (assoc 62 ent)) (setq ent (append ent (list (cons 62 1)))))
				(if (not entLTyp) (setq ent (append ent (list (cons 6 entLayerLTyp)))))
				(command ".-layer" "_unlock" entLayer "")

				(setq ent (subst (cons 8 clayer) (assoc 8 ent) ent))
				(setq ent (subst (cons 62 entColor) (assoc 62 ent) ent))

				(entmod ent)
				(entupd en)

				(setq pointer (1+ pointer))
				(setq en (ssname aw pointer))
				(princ (strcat "\rNoch zu bearbeiten: " (rtos (- anz pointer) 2 0) "       "))
			)
		)
	)

	;Ende
	(command "_.undo" "ende")
	(setvar "CMDECHO" syscmdecho)
	(print)
)

(princ "\nVereinfach - (c) Dipl.-Ing. V. Kleppel, www.cadwerk.com")
(princ "\nAufruf: vereinfach")
(print)